//////////////////////////////////////////////////////////////////////////
//                                                                      //
// tan.cpp -                                                            //
//                                                                      //
//                              //
//        .                          //
//                                                                      //
// Copyright (c) 2001 RC Module Inc.                                    //
//                                                                      //
//  :  ..                                                 //
//                                                                      //
//   $Revision:: 1     $      $Date:: 2/14/06 8:10p    $                //
//                                                                      //
//////////////////////////////////////////////////////////////////////////

#include "math.h"
#include "auxfd.h"

const LONG _iDPI  = 0x3243f6a8885a308d;
const LONG _iD2PI = 7244019458077122842;
const LONG _iDPI2 = 0x1921fb54442d1846; //  Pi/2
const LONG _iDPI4 = 0x0c90fdaa22168c23; //  Pi/4

const unsigned int _iPI_low  = 0x1898CC51;  //     Pi
const unsigned int _iPI2_low = 0x4C4C6629;  //     Pi/2

//   
//  iDTBL[i] = atan(1./pow(2,i)) * ((LONG)1 << i) * 0x4000000000000000
extern LONG _iDTBL[90];

//          
extern LONG _iDK[47];

#ifdef __cplusplus
extern "C" {
#endif

// tan --
//
//    
//
//    --.
//    CORDIC,    .
double tan(double f){

	LONG Mnt;               //   
	int Exp, Sgn;           //     
	int NewExp;             //   
	LONG Arg;               //   
	
    //   double
    DstrDouble( f, Mnt, Exp, Sgn);

    //    > Pi\4,   
    bool bReverse = false;

	//  
	if ( Exp ==0x400 && Mnt==0 )	//  1 +inf
		return 0;

	if ( Exp == -0x3ff && Mnt!=0 ){				//  3	Denormal
		return f;
	}

	if ( Exp ==0x400 && Mnt!=0 )					//  4 NAN
		return f;

	if ( Exp > 52 ){			//    
		if (!_FPIEEE_Flags)
			_FPIEEE_Signal( _FPIEEE_TLoss ); 
		return ConstructDouble( 0, 0, 0, 0);
	}

	if ( Exp < -27 )			//    
		return f;			//	lim(x->0)(sin(x)) = x

    //      
    Arg = Mnt << 8;

    //  ,   

    unsigned int Arg_low=0;

    /*	while (Exp>0){  //   n -  ,    
		Exp--;          //    
		Arg <<=1;
		if (Arg>_iDPI)
			Arg -= _iDPI;
	}
    */	
    while (Exp>0 || !(Arg&0x3000000000000000)){  //  n
		Exp--;
		Arg <<=1;
		Arg_low <<=1;
        //   \   
        if (Arg>_iDPI){
			if (Arg_low>=_iPI_low){
				Arg -= _iDPI;
				Arg_low -= _iPI_low;
			}
			else{
				Arg -= _iDPI+1;
				Arg_low += 0x80000000 - _iPI_low;
			}
		}
		if (Arg_low & 0x80000000){
			Arg_low &= 0x7fffffff;
			Arg++;
		}
	}
	LONG tmp = Arg; //       
	if (Exp == 0){
		tmp = _iDPI - tmp;		//   0 - n/2
		if (tmp<(_iDPI2)){
			Arg = tmp;
			Sgn = 1 - Sgn;
			while (!(Arg&0x1800000000000000)){
				Arg<<=1;
				Exp--;
			}
			Arg += _iPI_low >>(31+Exp);
			Arg -= Arg_low >>(31+Exp);
		}
		tmp = Arg;
	}
	if (Exp >= -1){
		Arg >>= -Exp;
		Exp = 0;
		tmp = _iDPI2 - Arg;		//   0 - n/4
		if ( tmp < _iDPI4 ){
			Arg = tmp;
			bReverse = !bReverse;
			while (!(Arg&0x1800000000000000)){
				Arg<<=1;
				Exp--;
			}
			Arg += _iPI2_low >>(31+Exp);
			Arg -= Arg_low >>(31+Exp);
		}
		Arg <<=1;
		Exp--;
	}

	Arg = Arg << 1;

	LONG y = 0; 
	NewExp = 0;

	//	 , , CORDIC
    //   SIN, COS

    if (Exp == 0){
		NewExp=0;
	}
	else{
		NewExp= Exp+1;
		Arg >>= 1;
	}
	int i = -NewExp;
	LONG x = _iDK[i];
	LONG x1 = x;

	LONG* tbl = _iDTBL+i;

    while (i<64+NewExp){  //  
		if (Arg >= 0){
			x1 -= y >> (i-NewExp);
			y += x >> (i++ +NewExp);
			Arg = (Arg - *(tbl++) )<<1;
		}
		else{
			x1 += y >> (i-NewExp);
			y -= x >> (i++ +NewExp);
			Arg = (Arg + *(tbl++) )<<1;
		}
		x = x1;
	}
	int ipNE = i+NewExp;
	while ( ipNE < 64){  //  
		if (Arg >= 0){
			y += x >> ipNE++;
			Arg = (Arg - *(tbl++))<<1;
		}
		else{
			y -= x >> ipNE++;
			Arg = (Arg + *(tbl++))<<1;
		}
	}
	if (bReverse){

		x = y;
		y = x1;
		NewExp = -NewExp;
	}

    //   TAN = SIN/COS
    //	y = _DivFix0x64(y, x, NewExp);

	i=0;
    x1=y;
    y=0;
	while (x<=x1){
		NewExp++;
		x<<=1;
	}
	NewExp--;
	x>>=1;
	while(i<62){
		tmp = x1;
		tmp -= x;
		if (tmp>=0){
			x1 = tmp;
			y++;
		}
		x1<<=1;
		y<<=1;
		i++;
	}

    //   
    if (y!=0){
		while (!(y & 0x4000000000000000)){
			y <<= 1;
			NewExp--;
		}
	}
	else
		NewExp = -0x3ff;

	y >>=9;	//    , ...
	y = (y>>1) + (y & 1); //   ,  .

	if (y == 0x0020000000000000){	
		y = 0;
		NewExp++;
	}
    //   double
    return ConstructDouble( y, NewExp, Sgn, 0);		
}

#ifdef __cplusplus
}
#endif
